import os
import sys
from os.path import abspath, dirname
currdir = dirname(abspath(__file__))+os.sep

import coopr.pyomo
import pyutilib.th as unittest
import pyutilib.subprocess


@unittest.skipIf(pyutilib.services.registered_executable("glpsol") is None, "The 'glpsol' executable is not available")
class Test(unittest.TestCase):

    def setUp(self):
        self.cwd = currdir
        os.chdir(self.cwd)

    def tearDown(self):
        os.chdir(self.cwd)

    def run_script(self, test):
        cwd = self.cwd+os.sep+test+os.sep
        os.chdir(cwd)
        pyutilib.subprocess.run(sys.executable+' script.py', outfile=cwd+os.sep+'script.log', cwd=cwd)
        self.assertFileEqualsBaseline(cwd+"script.log", cwd+"script.out")

    def test_s1(self):
        self.run_script('s1')

    def test_s2(self):
        self.run_script('s2')


if __name__ == "__main__":
   unittest.main()

